// Usage: dwnsmpl.js <sourceDirectory> <destinationDirectory>

// Define constants.

var cvsIllustrationDocument = 1;
var cvsImage = 8;
var cvsJPEGFormat = 10;

// Obtain the Arguments object and check that we have two arguments
// of string type. The first argument is the source and the second
// the destination directory.

var args = WScript.Arguments;

if (args.Count() == 2)
{
  var srcDir = args.Item(0);
  var dstDir = args.Item(1);

  if (srcDir.constructor == String && dstDir.constructor == String)
  {
    // Start Canvas and create an illustration document.

    var cvApp = new ActiveXObject("Canvas.Application");
    var doc = cvApp.Documents.Add(cvsIllustrationDocument);

    // Create a file system object.

    var fso = new ActiveXObject("Scripting.FileSystemObject");
    var fldr = fso.GetFolder(srcDir);
    
    var srcFile;
    var doc;
    var img;

    // Enumerate the files in the source directory and loop
    // over them.

    var en = new Enumerator(fldr.Files);
    for (; !en.atEnd(); en.moveNext())
    {
       srcFile = en.item();

      // Check if the file is a JPEG file.

      if (IsJPEGFile(srcFile))
       {
         // Place the JPEG file in the Canvas document.

         obj = doc.Place(srcFile.Path);

        // Make sure the result of the placement is an image and obtain
        // a reference to it.

        if (obj.Type == cvsImage)
         {
           img = obj.Image;

           // If the image resolution if higher than 72 dpi, set it to
           // 72 dpi.

           if (img.Resolution > 72)
           {
             img.SetResolution(72, false);

             // Attach "ds_" (for DownSample) to the front
             // of the file name and append the name to the
             // destination directory to get the destination
             // path.

             var dstPath = "";
             dstPath += dstDir + "/" + "ds_" + srcFile.Name;

             // Save the downsampled JPEG image to the destination
             // path.

             doc.SaveAs(dstPath, cvsJPEGFormat);
           }
         }

         // Delete the placed object.

         obj.Delete();
       }
    }
  }
}


// Check if a file is a JPEG file by converting
// the file name to uppercase and searching for
// the substring ".JPG" in it.

function IsJPEGFile(file)
{
  var ucName = file.Name.toUpperCase();
  if (ucName.indexOf(".JPG") != -1)
  {
    return true;
  }
  
  return false;
}
